### Description
🚨 Review the [guidelines for contributing](../CONTRIBUTING.md) to this repository. 🚨

Please explain the changes you made here.

You can explain individual changes as a list:

- [ ] feature name: extra details
- [ ] bug: extra details (resolves #`issue_number`)

### Checklist
Please check if your PR fulfills the following requirements:
- [ ] Code compiles correctly (`npm run build`)
- [ ] Code is linted
- [ ] Created tests which fail without the change (if possible) 
- All **relevant** tests are passing
  - [ ] Server Unit Tests
  - [ ] Client Unit Tests
  - [ ] Achievements Unit Tests
  - [ ] API Tests
  - [ ] E2E Tests
- [ ] Extended the README / documentation, if necessary